@@ -0,0 +1,129 @@
+#!/bin/sh
+#
+# nginx - this script starts and stops the nginx daemon
+#
+# chkconfig: - 85 15
+# description: Nginx is an HTTP(S) server, HTTP(S) reverse \
+# proxy and IMAP/POP3 proxy server
+# processname: nginx
+# config: /etc/nginx/nginx.conf
+# config: /etc/sysconfig/nginx
+# pidfile: /var/run/nginx.pid
+
+# Source function library.
+. /etc/rc.d/init.d/functions
+
+# Source networking configuration.
+. /etc/sysconfig/network
+
+# Check that networking is up.
+[ "$NETWORKING" = "no" ] && exit 0
+
+nginx="/usr/sbin/nginx"
+prog=$(basename $nginx)
+
+NGINX_CONF_FILE="/etc/nginx/nginx.conf"
+
+[ -f /etc/sysconfig/nginx ] && . /etc/sysconfig/nginx
+
+lockfile=/var/lock/subsys/nginx
+
+start() {
+ [ -x $nginx ] || exit 5
+ [ -f $NGINX_CONF_FILE ] || exit 6
+ echo -n $"Starting $prog: "
+ daemon $nginx -c $NGINX_CONF_FILE
+ retval=$?
+ echo
+ [ $retval -eq 0 ] && touch $lockfile
+ return $retval
+}
+
+stop() {
+ echo -n $"Stopping $prog: "
+ killproc $prog
+ retval=$?
+ echo
+ [ $retval -eq 0 ] && rm -f $lockfile
+ return $retval
+}
+
+restart() {
+ configtest_q || configtest || return 6
+ stop
+ start
+}
+
+reload() {
+ configtest_q || configtest || return 6
+ echo -n $"Reloading $prog: "
+ killproc $nginx -HUP
+ echo
+}
+
+configtest() {
+ $nginx -t -c $NGINX_CONF_FILE
+}
+
+configtest_q() {
+ configtest >/dev/null 2>&1
+}
+
+rh_status() {
+ status $prog
+}
+
+rh_status_q() {
+ rh_status >/dev/null 2>&1
+}
+
+# Online upgrade nginx binary on the fly, with no downtime.
+# details: http://sysoev.ru/nginx/docs/control.html#upgrade
+upgrade() {
+ configtest_q || configtest || return 6
+ echo -n $"Upgrading $prog: "
+ kill -USR2 `cat /var/run/$prog.pid`
+ sleep 1
+ if test -f /var/run/$prog.pid.oldbin
+ then
+ killproc -p /var/run/$prog.pid.oldbin -QUIT
+ echo
+ else
+ failure $"$prog online upgrade"
+ echo
+ exit 1
+ fi
+}
+
+case "$1" in
+ start)
+ rh_status_q && exit 0
+ $1
+ ;;
+ stop)
+ rh_status_q || exit 0
+ $1
+ ;;
+ reload)
+ rh_status_q || exit 7
+ $1
+ ;;
+ upgrade|force-reload)
+ rh_status_q || exit 7
+ upgrade
+ ;;
+ condrestart|try-restart)
+ rh_status_q || exit 7
+ restart
+ ;;
+ restart|configtest)
+ $1
+ ;;
+ status|status_q)
+ rh_$1
+ ;;
+ *)
+ echo $"Usage: $0 {start|stop|reload|force-reload|restart|try-restart|status|configtest}"
+ exit 2
+esac
+
|